diff --git a/include/user_config.h b/include/user_config.h
index 4ad1f2e..644e5b0 100644
--- a/include/user_config.h
+++ b/include/user_config.h
@@ -7,7 +7,7 @@
 /*DEFAULT CONFIGURATIONS*/
 
 #define MQTT_HOST			"mqtt.yourdomain.com" //or "192.168.11.1"
-#define MQTT_PORT			8440
+#define MQTT_PORT			1880
 #define MQTT_BUF_SIZE		1024
 #define MQTT_KEEPALIVE		120	 /*second*/
 
@@ -17,12 +17,14 @@
 
 
 #define STA_SSID "DVES_HOME"
-#define STA_PASS "wifipassword"
+#define STA_PASS "yourpassword"
 #define STA_TYPE AUTH_WPA2_PSK
 
 #define MQTT_RECONNECT_TIMEOUT 	5	/*second*/
 
 #define CLIENT_SSL_ENABLE
+#define DEFAULT_SECURITY	0
 
+#define QUEUE_BUFFER_SIZE		 		2048
 
 #endif
diff --git a/user/config.c b/user/config.c
index ea8f2fa..ca3f624 100644
--- a/user/config.c
+++ b/user/config.c
@@ -95,7 +95,7 @@ void CFG_Load()
 		os_sprintf(sysCfg.mqtt_user, "%s", MQTT_USER);
 		os_sprintf(sysCfg.mqtt_pass, "%s", MQTT_PASS);
 
-		sysCfg.security = SEC_NONSSL;	/* default non ssl */
+		sysCfg.security = DEFAULT_SECURITY;	/* default non ssl */
 
 		sysCfg.mqtt_keepalive = MQTT_KEEPALIVE;
 
diff --git a/user/mqtt.c b/user/mqtt.c
index 9b7b747..ec9f866 100644
--- a/user/mqtt.c
+++ b/user/mqtt.c
@@ -38,20 +38,15 @@
 #include "user_config.h"
 #include "config.h"
 #include "driver/uart.h"
-#include "str_queue.h"
 #include "mqtt.h"
-
+#include "queue.h"
 
 #define MQTT_TASK_PRIO        		0
 #define MQTT_TASK_QUEUE_SIZE    	1
 
-#define MAX_TOPIC_QUEUE		 		5
-#define MAX_TOPIC_LEN		 		64
-
-#define MAX_PUBLISH_QUEUE		 	5
-#define MAX_PUBLISH_LEN		 		1024
-
-
+#ifndef QUEUE_BUFFER_SIZE
+#define QUEUE_BUFFER_SIZE		 		2048
+#endif
 
 unsigned char *default_certificate;
 unsigned int default_certificate_len = 0;
@@ -60,7 +55,6 @@ unsigned int default_private_key_len = 0;
 
 os_event_t mqtt_procTaskQueue[MQTT_TASK_QUEUE_SIZE];
 
-
 LOCAL void ICACHE_FLASH_ATTR
 mqtt_dns_found(const char *name, ip_addr_t *ipaddr, void *arg)
 {
@@ -173,26 +167,7 @@ mqtt_tcpclient_recv(void *arg, char *pdata, unsigned short len)
 					client->connectedCb((uint32_t*)client);
 			}
 			break;
-		case MQTT_SUBSCIBE_SENDING:
-			if(mqtt_get_type(client->mqtt_state.in_buffer) != MQTT_MSG_TYPE_SUBACK){
-				INFO("MQTT: Invalid packet\r\n");
-				if(client->security){
-					espconn_secure_disconnect(client->pCon);
-				}
-				else{
-					espconn_disconnect(client->pCon);
-				}
-			} else {
-				if(QUEUE_IsEmpty(&client->topicQueue)){
-					client->connState = MQTT_DATA;
 
-				} else {
-					client->connState = MQTT_SUBSCIBE_SEND;
-				}
-				INFO("MQTT: Subscribe successful\r\n");
-
-			}
-			break;
 		case MQTT_DATA:
 			client->mqtt_state.message_length_read = len;
 			client->mqtt_state.message_length = mqtt_get_total_length(client->mqtt_state.in_buffer, client->mqtt_state.message_length_read);
@@ -302,12 +277,18 @@ mqtt_tcpclient_sent_cb(void *arg)
 void ICACHE_FLASH_ATTR mqtt_timer(void *arg)
 {
 	MQTT_Client* client = (MQTT_Client*)arg;
+	mqtt_message_t* outbound_message;
+
 	if(client->connState == MQTT_DATA){
 		client->keepAliveTick ++;
 		if(client->keepAliveTick > client->mqtt_state.connect_info->keepalive){
 
 			INFO("\r\nMQTT: Send keepalive packet to %s:%d!\r\n", client->host, client->port);
-			client->mqtt_state.outbound_message = mqtt_msg_pingreq(&client->mqtt_state.mqtt_connection);
+			outbound_message = mqtt_msg_pingreq(&client->mqtt_state.mqtt_connection);
+			if(QUEUE_Puts(&client->msgQueue, outbound_message->data, outbound_message->length) == -1){
+				INFO("MQTT: Exceed the amount of queues\r\n");
+			}
+
 			client->keepAliveTick = 0;
 			system_os_post(MQTT_TASK_PRIO, 0, (os_param_t)client);
 		}
@@ -377,32 +358,41 @@ mqtt_tcpclient_recon_cb(void *arg, sint8 errType)
 }
 
 
-void ICACHE_FLASH_ATTR
+BOOL ICACHE_FLASH_ATTR
 MQTT_Publish(MQTT_Client *client, const char* topic, const char* data, int data_length, int qos, int retain)
 {
-	if(client->connState != MQTT_DATA)
-		return;
-	INFO("MQTT: sending publish...\r\n");
-	client->mqtt_state.outbound_message = mqtt_msg_publish(&client->mqtt_state.mqtt_connection,
-                                                 topic, data, data_length,
-                                                 qos, retain,
-                                                 &client->mqtt_state.pending_msg_id);
-  system_os_post(MQTT_TASK_PRIO, 0, (os_param_t)client);
-
+	mqtt_message_t* outbound_message;
+
+	INFO("MQTT: queuing publish...\r\n");
+	outbound_message = mqtt_msg_publish(&client->mqtt_state.mqtt_connection,
+										 topic, data, data_length,
+										 qos, retain,
+										 &client->mqtt_state.pending_msg_id);
+	if(QUEUE_Puts(&client->msgQueue, outbound_message->data, outbound_message->length) == -1){
+		INFO("MQTT: Exceed the amount of queues\r\n");
+		return FALSE;
+	}
+	system_os_post(MQTT_TASK_PRIO, 0, (os_param_t)client);
+	return TRUE;
 }
 
-void ICACHE_FLASH_ATTR
-MQTT_Subscribe(MQTT_Client *client, char* topic)
+BOOL ICACHE_FLASH_ATTR
+MQTT_Subscribe(MQTT_Client *client, char* topic, uint8_t qos)
 {
+	mqtt_message_t* outbound_message;
+
 	INFO("MQTT: subscribe, topic\"%s\" at broker %s:%d\r\n", topic, client->host, client->port);
 
-	if(QUEUE_Puts(&client->topicQueue, topic) == -1){
+	outbound_message = mqtt_msg_subscribe(&client->mqtt_state.mqtt_connection,
+											topic, 0,
+											&client->mqtt_state.pending_msg_id);
+
+	if(QUEUE_Puts(&client->msgQueue, outbound_message->data, outbound_message->length) == -1){
 		INFO("MQTT: Exceed the amount of queues\r\n");
-	} else {
-		if(client->connState == MQTT_DATA)
-			client->connState = MQTT_SUBSCIBE_SEND;
+		return FALSE;
 	}
 	system_os_post(MQTT_TASK_PRIO, 0, (os_param_t)client);
+	return TRUE;
 }
 
 void ICACHE_FLASH_ATTR
@@ -435,34 +425,16 @@ MQTT_Task(os_event_t *e)
 		INFO("MQTT: Send mqtt connection info, to broker %s:%d\r\n", client->host, client->port);
 		client->connState = MQTT_CONNECT_SENDING;
 		client->mqtt_state.outbound_message = NULL;
-		break;
-	case MQTT_SUBSCIBE_SEND:
-		if(QUEUE_Gets(&client->topicQueue, topic) == 0){
-			client->mqtt_state.outbound_message = mqtt_msg_subscribe(&client->mqtt_state.mqtt_connection,
-																	topic, 0,
-																   &client->mqtt_state.pending_msg_id);
-			client->mqtt_state.pending_msg_type = MQTT_MSG_TYPE_SUBSCRIBE;
-			if(client->security){
-				espconn_secure_sent(client->pCon, client->mqtt_state.outbound_message->data, client->mqtt_state.outbound_message->length);
-			}
-			else{
-				espconn_sent(client->pCon, client->mqtt_state.outbound_message->data, client->mqtt_state.outbound_message->length);
-			}
-
-			client->mqtt_state.outbound_message = NULL;
-			client->connState = MQTT_SUBSCIBE_SENDING;
-		} else {
-			client->connState = MQTT_DATA;
-		}
-
 		break;
 	case MQTT_DATA:
-		if(client->mqtt_state.outbound_message != NULL){
+
+		if(QUEUE_Gets(&client->msgQueue, client->mqtt_state.mqtt_connection.buffer, &client->mqtt_state.mqtt_connection.buffer_length, MQTT_BUF_SIZE) == 0){
+			INFO("MQTT: Sending..\r\n");
 			if(client->security){
-				espconn_secure_sent(client->pCon, client->mqtt_state.outbound_message->data, client->mqtt_state.outbound_message->length);
+				espconn_secure_sent(client->pCon, client->mqtt_state.mqtt_connection.buffer, client->mqtt_state.mqtt_connection.buffer_length);
 			}
 			else{
-				espconn_sent(client->pCon, client->mqtt_state.outbound_message->data, client->mqtt_state.outbound_message->length);
+				espconn_sent(client->pCon, client->mqtt_state.mqtt_connection.buffer, client->mqtt_state.mqtt_connection.buffer_length);
 			}
 
 			client->mqtt_state.outbound_message = NULL;
@@ -490,11 +462,8 @@ void MQTT_InitConnection(MQTT_Client *mqttClient, uint8_t* host, uint32 port, ui
 	mqttClient->port = port;
 	mqttClient->security = security;
 	mqttClient->pCon->reverse = mqttClient;
-
-
 	espconn_regist_connectcb(mqttClient->pCon, mqtt_tcpclient_connect_cb);
 	espconn_regist_reconcb(mqttClient->pCon, mqtt_tcpclient_recon_cb);
-
 }
 
 
@@ -512,8 +481,6 @@ void MQTT_InitClient(MQTT_Client *mqttClient, uint8_t* client_id, uint8_t* clien
 	mqttClient->connect_info.clean_session = 1;
 	//mqttClient->mqtt_state = (mqtt_state_t *)os_zalloc(sizeof(mqtt_state_t));
 
-
-
 	mqttClient->mqtt_state.in_buffer = (uint8_t *)os_zalloc(MQTT_BUF_SIZE);
 	mqttClient->mqtt_state.in_buffer_length = MQTT_BUF_SIZE;
 	mqttClient->mqtt_state.out_buffer =  (uint8_t *)os_zalloc(MQTT_BUF_SIZE);
@@ -526,11 +493,10 @@ void MQTT_InitClient(MQTT_Client *mqttClient, uint8_t* client_id, uint8_t* clien
 	os_timer_setfn(&mqttClient->mqttTimer, (os_timer_func_t *)mqtt_timer, mqttClient);
 	os_timer_arm(&mqttClient->mqttTimer, 1000, 1);
 
-	QUEUE_Init(&mqttClient->topicQueue, MAX_TOPIC_LEN, MAX_TOPIC_QUEUE);
+	QUEUE_Init(&mqttClient->msgQueue, QUEUE_BUFFER_SIZE);
 
 	system_os_task(MQTT_Task, MQTT_TASK_PRIO, mqtt_procTaskQueue, MQTT_TASK_QUEUE_SIZE);
 	system_os_post(MQTT_TASK_PRIO, 0, (os_param_t)mqttClient);
-
 }
 
 void MQTT_Connect(MQTT_Client *mqttClient)
@@ -543,14 +509,11 @@ void MQTT_Connect(MQTT_Client *mqttClient)
 		else {
 			espconn_connect(mqttClient->pCon);
 		}
-
 	}
 	else {
 		INFO("TCP: Connect to domain %s:%d\r\n", mqttClient->host, mqttClient->port);
 		espconn_gethostbyname(mqttClient->pCon, mqttClient->host, &mqttClient->ip, mqtt_dns_found);
 	}
-
-
 	mqttClient->connState = TCP_CONNECTING;
 }
 void MQTT_OnConnected(MQTT_Client *mqttClient, MqttCallback connectedCb)
diff --git a/user/mqtt.h b/user/mqtt.h
index 51f549a..853e329 100644
--- a/user/mqtt.h
+++ b/user/mqtt.h
@@ -31,7 +31,8 @@
 #define USER_AT_MQTT_H_
 #include "mqtt_msg.h"
 #include "user_interface.h"
-#include "str_queue.h"
+
+#include "queue.h"
 typedef struct mqtt_event_data_t
 {
   uint8_t type;
@@ -99,7 +100,7 @@ typedef struct  {
 	uint32_t keepAliveTick;
 	uint32_t reconnectTick;
 	tConnState connState;
-	STR_QUEUE topicQueue;
+	QUEUE msgQueue;
 } MQTT_Client;
 
 #define SEC_NONSSL 0
@@ -125,8 +126,8 @@ void MQTT_OnConnected(MQTT_Client *mqttClient, MqttCallback connectedCb);
 void MQTT_OnDisconnected(MQTT_Client *mqttClient, MqttCallback disconnectedCb);
 void MQTT_OnPublished(MQTT_Client *mqttClient, MqttCallback publishedCb);
 void MQTT_OnData(MQTT_Client *mqttClient, MqttDataCallback dataCb);
-void MQTT_Subscribe(MQTT_Client *client, char* topic);
+BOOL MQTT_Subscribe(MQTT_Client *client, char* topic, uint8_t qos);
 void MQTT_Connect(MQTT_Client *mqttClient);
-void MQTT_Publish(MQTT_Client *client, const char* topic, const char* data, int data_length, int qos, int retain);
+BOOL MQTT_Publish(MQTT_Client *client, const char* topic, const char* data, int data_length, int qos, int retain);
 
 #endif /* USER_AT_MQTT_H_ */
diff --git a/user/proto.c b/user/proto.c
new file mode 100644
index 0000000..5673da0
--- /dev/null
+++ b/user/proto.c
@@ -0,0 +1,129 @@
+#include "proto.h"
+#include "ringbuf.h"
+I8 PROTO_Init(PROTO_PARSER *parser, PROTO_PARSE_CALLBACK *completeCallback, U8 *buf, U16 bufSize)
+{
+    parser->buf = buf;
+    parser->bufSize = bufSize;
+    parser->dataLen = 0;
+    parser->callback = completeCallback;
+    parser->isEsc = 0;
+    return 0;
+}
+
+I8 PROTO_ParseByte(PROTO_PARSER *parser, U8 value)
+{	
+	switch(value){
+		case 0x7D:
+			parser->isEsc = 1;
+			break;
+		
+		case 0x7E:
+			parser->dataLen = 0;
+			parser->isEsc = 0;
+			parser->isBegin = 1;
+			break;
+		
+		case 0x7F:
+			if (parser->callback != NULL)
+				parser->callback();
+			parser->isBegin = 0;
+			return 0;
+			break;
+		
+		default:
+			if(parser->isBegin == 0) break;
+			
+			if(parser->isEsc){
+				value ^= 0x20;
+				parser->isEsc = 0;
+			}
+				
+			if(parser->dataLen < parser->bufSize)
+				parser->buf[parser->dataLen++] = value;
+				
+			break;
+	}
+    return -1;
+}
+
+I8 PROTO_Parse(PROTO_PARSER *parser, U8 *buf, U16 len)
+{
+    while(len--)
+        PROTO_ParseByte(parser, *buf++);
+
+    return 0;
+}
+I16 PROTO_ParseRb(RINGBUF* rb, U8 *bufOut, U16* len, U16 maxBufLen)
+{
+	U8 c;
+
+	PROTO_PARSER proto;
+	PROTO_Init(&proto, NULL, bufOut, maxBufLen);
+	while(RINGBUF_Get(rb, &c) == 0){
+		if(PROTO_ParseByte(&proto, c) == 0){
+			*len = proto.dataLen;
+			return 0;
+		}
+	}
+	return -1;
+}
+I16 PROTO_Add(U8 *buf, const U8 *packet, I16 bufSize)
+{
+    U16 i = 2;
+    U16 len = *(U16*) packet;
+
+    if (bufSize < 1) return -1;
+
+    *buf++ = 0x7E;
+    bufSize--;
+
+    while (len--) {
+        switch (*packet) {
+        case 0x7D:
+        case 0x7E:
+        case 0x7F:
+            if (bufSize < 2) return -1;
+            *buf++ = 0x7D;
+            *buf++ = *packet++ ^ 0x20;
+            i += 2;
+            bufSize -= 2;
+            break;
+        default:
+            if (bufSize < 1) return -1;
+            *buf++ = *packet++;
+            i++;
+            bufSize--;
+            break;
+        }
+    }
+
+    if (bufSize < 1) return -1;
+    *buf++ = 0x7F;
+
+    return i;
+}
+
+I16 PROTO_AddRb(RINGBUF *rb, const U8 *packet, I16 len)
+{
+    U16 i = 2;
+
+    if(RINGBUF_Put(rb, 0x7E) == -1) return -1;
+    while (len--) {
+        switch (*packet) {
+        case 0x7D:
+        case 0x7E:
+        case 0x7F:
+        	if(RINGBUF_Put(rb, 0x7D) == -1) return -1;
+        	if(RINGBUF_Put(rb, *packet++ ^ 0x20) == -1) return -1;
+            i += 2;
+            break;
+        default:
+        	if(RINGBUF_Put(rb, *packet++) == -1) return -1;
+            i++;
+            break;
+        }
+    }
+    if(RINGBUF_Put(rb, 0x7F) == -1) return -1;
+    return i;
+}
+
diff --git a/user/proto.h b/user/proto.h
new file mode 100644
index 0000000..ce46aa5
--- /dev/null
+++ b/user/proto.h
@@ -0,0 +1,32 @@
+/* 
+ * File:   proto.h
+ * Author: ThuHien
+ *
+ * Created on November 23, 2012, 8:57 AM
+ */
+
+#ifndef _PROTO_H_
+#define	_PROTO_H_
+#include <stdlib.h>
+#include "typedef.h"
+#include "ringbuf.h"
+
+typedef void(PROTO_PARSE_CALLBACK)();
+
+typedef struct{
+	U8 *buf;
+	U16 bufSize;
+	U16 dataLen;
+	U8 isEsc;
+	U8 isBegin;
+	PROTO_PARSE_CALLBACK* callback;
+}PROTO_PARSER;
+
+I8 PROTO_Init(PROTO_PARSER *parser, PROTO_PARSE_CALLBACK *completeCallback, U8 *buf, U16 bufSize);
+I8 PROTO_Parse(PROTO_PARSER *parser, U8 *buf, U16 len);
+I16 PROTO_Add(U8 *buf, const U8 *packet, I16 bufSize);
+I16 PROTO_AddRb(RINGBUF *rb, const U8 *packet, I16 len);
+I8 PROTO_ParseByte(PROTO_PARSER *parser, U8 value);
+I16 PROTO_ParseRb(RINGBUF *rb, U8 *bufOut, U16* len, U16 maxBufLen);
+#endif
+
diff --git a/user/queue.c b/user/queue.c
new file mode 100644
index 0000000..147b503
--- /dev/null
+++ b/user/queue.c
@@ -0,0 +1,51 @@
+/* str_queue.c
+*
+* Copyright (c) 2014-2015, Tuan PM <tuanpm at live dot com>
+* All rights reserved.
+*
+* Redistribution and use in source and binary forms, with or without
+* modification, are permitted provided that the following conditions are met:
+*
+* * Redistributions of source code must retain the above copyright notice,
+* this list of conditions and the following disclaimer.
+* * Redistributions in binary form must reproduce the above copyright
+* notice, this list of conditions and the following disclaimer in the
+* documentation and/or other materials provided with the distribution.
+* * Neither the name of Redis nor the names of its contributors may be used
+* to endorse or promote products derived from this software without
+* specific prior written permission.
+*
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+* POSSIBILITY OF SUCH DAMAGE.
+*/
+#include "queue.h"
+
+#include "user_interface.h"
+#include "osapi.h"
+#include "os_type.h"
+#include "mem.h"
+#include "proto.h"
+void QUEUE_Init(QUEUE *queue, int bufferSize)
+{
+	queue->buf = (uint8_t*)os_zalloc(bufferSize);
+	RINGBUF_Init(&queue->rb, queue->buf, bufferSize);
+}
+int32_t QUEUE_Puts(QUEUE *queue, uint8_t* buffer, uint16_t len)
+{
+	return PROTO_AddRb(&queue->rb, buffer, len);
+}
+int32_t QUEUE_Gets(QUEUE *queue, uint8_t* buffer, uint16_t* len, uint16_t maxLen)
+{
+
+	return PROTO_ParseRb(&queue->rb, buffer, len, maxLen);
+}
+
diff --git a/user/queue.h b/user/queue.h
new file mode 100644
index 0000000..5071f06
--- /dev/null
+++ b/user/queue.h
@@ -0,0 +1,44 @@
+/* str_queue.h --
+*
+* Copyright (c) 2014-2015, Tuan PM <tuanpm at live dot com>
+* All rights reserved.
+*
+* Redistribution and use in source and binary forms, with or without
+* modification, are permitted provided that the following conditions are met:
+*
+* * Redistributions of source code must retain the above copyright notice,
+* this list of conditions and the following disclaimer.
+* * Redistributions in binary form must reproduce the above copyright
+* notice, this list of conditions and the following disclaimer in the
+* documentation and/or other materials provided with the distribution.
+* * Neither the name of Redis nor the names of its contributors may be used
+* to endorse or promote products derived from this software without
+* specific prior written permission.
+*
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+* POSSIBILITY OF SUCH DAMAGE.
+*/
+
+#ifndef USER_QUEUE_H_
+#define USER_QUEUE_H_
+#include "os_type.h"
+#include "ringbuf.h"
+typedef struct {
+	uint8_t *buf;
+	RINGBUF rb;
+} QUEUE;
+
+void QUEUE_Init(QUEUE *queue, int bufferSize);
+int32_t QUEUE_Puts(QUEUE *queue, uint8_t* buffer, uint16_t len);
+int32_t QUEUE_Gets(QUEUE *queue, uint8_t* buffer, uint16_t* len, uint16_t maxLen);
+int32_t QUEUE_IsEmpty(QUEUE *queue);
+#endif /* USER_QUEUE_H_ */
diff --git a/user/ringbuf.c b/user/ringbuf.c
new file mode 100644
index 0000000..9947fd4
--- /dev/null
+++ b/user/ringbuf.c
@@ -0,0 +1,67 @@
+/**
+* \file
+*		Ring Buffer library
+*/
+
+#include "ringbuf.h"
+
+
+/**
+* \brief init a RINGBUF object
+* \param r pointer to a RINGBUF object
+* \param buf pointer to a byte array
+* \param size size of buf
+* \return 0 if successfull, otherwise failed
+*/
+I16 RINGBUF_Init(RINGBUF *r, U8* buf, I32 size)
+{
+	if(r == NULL || buf == NULL || size < 2) return -1;
+	
+	r->p_o = r->p_r = r->p_w = buf;
+	r->fill_cnt = 0;
+	r->size = size;
+	
+	return 0;
+}
+/**
+* \brief put a character into ring buffer
+* \param r pointer to a ringbuf object
+* \param c character to be put
+* \return 0 if successfull, otherwise failed
+*/
+I16 RINGBUF_Put(RINGBUF *r, U8 c)
+{
+	if(r->fill_cnt>=r->size)return -1;		// ring buffer is full, this should be atomic operation
+	
+
+	r->fill_cnt++;							// increase filled slots count, this should be atomic operation
+
+	
+	*r->p_w++ = c;							// put character into buffer
+	
+	if(r->p_w >= r->p_o + r->size)			// rollback if write pointer go pass
+		r->p_w = r->p_o;					// the physical boundary
+	
+	return 0;
+}
+/**
+* \brief get a character from ring buffer
+* \param r pointer to a ringbuf object
+* \param c read character
+* \return 0 if successfull, otherwise failed
+*/
+I16 RINGBUF_Get(RINGBUF *r, U8* c)
+{
+	if(r->fill_cnt<=0)return -1;				// ring buffer is empty, this should be atomic operation
+	
+
+	r->fill_cnt--;								// decrease filled slots count
+
+	
+	*c = *r->p_r++;								// get the character out
+	
+	if(r->p_r >= r->p_o + r->size)				// rollback if write pointer go pass
+		r->p_r = r->p_o;						// the physical boundary
+	
+	return 0;
+}
diff --git a/user/ringbuf.h b/user/ringbuf.h
new file mode 100644
index 0000000..602baa0
--- /dev/null
+++ b/user/ringbuf.h
@@ -0,0 +1,19 @@
+#ifndef _RING_BUF_H_
+#define _RING_BUF_H_
+
+#include <os_type.h>
+#include <stdlib.h>
+#include "typedef.h"
+
+typedef struct{
+	U8* p_o;				/**< Original pointer */
+	U8* volatile p_r;		/**< Read pointer */
+	U8* volatile p_w;		/**< Write pointer */
+	volatile I32 fill_cnt;	/**< Number of filled slots */
+	I32 size;				/**< Buffer size */
+}RINGBUF;
+
+I16 RINGBUF_Init(RINGBUF *r, U8* buf, I32 size);
+I16 RINGBUF_Put(RINGBUF *r, U8 c);
+I16 RINGBUF_Get(RINGBUF *r, U8* c);
+#endif
diff --git a/user/typedef.h b/user/typedef.h
new file mode 100644
index 0000000..a4c69d6
--- /dev/null
+++ b/user/typedef.h
@@ -0,0 +1,17 @@
+/**
+* \file
+*		Standard Types definition
+*/
+
+#ifndef _TYPE_DEF_H_
+#define _TYPE_DEF_H_
+
+typedef char I8;
+typedef unsigned char U8;
+typedef short I16;
+typedef unsigned short U16;
+typedef long I32;
+typedef unsigned long U32;
+typedef unsigned long long U64;
+
+#endif
diff --git a/user/user_main.c b/user/user_main.c
index 54dfee1..83f5257 100644
--- a/user/user_main.c
+++ b/user/user_main.c
@@ -49,8 +49,10 @@ void mqttConnectedCb(uint32_t *args)
 {
 	MQTT_Client* client = (MQTT_Client*)args;
 	INFO("MQTT: Connected\r\n");
-	MQTT_Subscribe(&mqttClient, "/test/topic");
-	MQTT_Subscribe(&mqttClient, "/test2/topic");
+	MQTT_Subscribe(&mqttClient, "/mqtt/topic/1", 0);
+	MQTT_Subscribe(&mqttClient, "/mqtt/topic/2", 0);
+	MQTT_Publish(client, "/mqtt/topic/2", "hello", 5, 0, 0);
+	MQTT_Publish(client, "/mqtt/topic/1", "hello2", 6, 0, 0);
 
 }
 
@@ -79,8 +81,6 @@ void mqttDataCb(uint32_t *args, const char* topic, uint32_t topic_len, const cha
 
 	INFO("MQTT topic: %s, data: %s \r\n", topicBuf, dataBuf);
 
-	/* Echo back to /echo channel*/
-	MQTT_Publish(client, "/echo", dataBuf, data_len, 0, 0);
 }
 
 
